



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>linux源码Makefile详解(完整)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">linux源码Makefile详解(完整)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-09 04:45:40 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>转自：<a href="http://www.cnblogs.com/Daniel-G/p/3286614.html" rel="external nofollow noreferrer">http://www.cnblogs.com/Daniel-G/p/3286614.html</a></p>
<p>随着 Linux 操作系统的广泛应用，特别是 Linux 在嵌入式领域的发展，越来越多的人开始投身到 Linux 内核级的开发中。面对日益庞大的 Linux 内核源代码，开发者在完成自己的内核代码后，都将面临着同样的问题，即如何将源代码融入到 Linux 内核中，增加相应的 Linux 配置选项，并最终被编译进 Linux 内核。这就需要了解 Linux 的内核配置系统。</p>
<div>众所周知，Linux 内核是由分布在全球的 Linux 爱好者共同开发的，Linux 内核每天都面临着许多新的变化。但是，Linux 内核的组织并没有出现混乱的现象，反而显得非常的简洁，而且具有很好的扩展性，开发人员可以很方便的向 Linux 内核中增加新的内容。原因之一就是 Linux 采用了模块化的内核配置系统，从而保证了内核的扩展性。</div>
<div>本文首先分析了 Linux 内核中的配置系统结构，然后，解释了 Makefile 和配置文件的格式以及配置语句的含义，最后，通过一个简单的例子--TEST Driver，具体说明如何将自行开发的代码加入到 Linux 内核中。在下面的文章中，不可能解释所有的功能和命令，只对那些常用的进行解释，至于那些没有讨论到的，请读者参考后面的参考文献。</div>
<div>1． 配置系统的基本结构</div>
<div>Linux内核的配置系统由三个部分组成，分别是：</div>
<ol><li>Makefile：分布在 Linux 内核源代码中的 Makefile，定义 Linux 内核的编译规则；</li>
<li>配置文件（config.in）：给用户提供配置选择的功能；</li>
<li>配置工具：包括配置命令解释器（对配置脚本中使用的配置命令进行解释）和配置用户界面（提供基于字符界面、基于 Ncurses 图形界面以及基于 Xwindows 图形界面的用户配置界面，各自对应于 Make config、Make menuconfig 和 make xconfig）。</li></ol>
<div>这些配置工具都是使用脚本语言，如 Tcl/TK、Perl 编写的（也包含一些用 C 编写的代码）。本文并不是对配置系统本身进行分析，而是介绍如何使用配置系统。所以，除非是配置系统的维护者，一般的内核开发者无须了解它们的原理，只需要知道如何编写 Makefile 和配置文件就可以。所以，在本文中，我们只对 Makefile 和配置文件进行讨论。另外，凡是涉及到与具体 CPU 体系结构相关的内容，我们都以 ARM 为例，这样不仅可以将讨论的问题明确化，而且对内容本身不产生影响。</div>
<div>2． Makefile</div>
<div><strong>2.1 Makefile 概述</strong></div>
<div>Makefile 的作用是根据配置的情况，构造出需要编译的源文件列表，然后分别编译，并把目标代码链接到一起，最终形成 Linux 内核二进制文件。</div>
<div>由于 Linux 内核源代码是按照树形结构组织的，所以 Makefile 也被分布在目录树中。Linux 内核中的 Makefile 以及与 Makefile 直接相关的文件有：</div>
<ol><li>Makefile：顶层 Makefile，是整个内核配置、编译的总体控制文件。</li>
<li>.config：内核配置文件，包含由用户选择的配置选项，用来存放内核配置后的结果（如 make config）。</li>
<li>arch/*/Makefile：位于各种 CPU 体系目录下的 Makefile，如 arch/arm/Makefile，是针对特定平台的 Makefile。</li>
<li>各个子目录下的 Makefile：比如 drivers/Makefile，负责所在子目录下源代码的管理。</li>
<li>Rules.make：规则文件，被所有的 Makefile 使用。</li></ol>
<div>用户通过 make config 配置后，产生了 .config。顶层 Makefile 读入 .config 中的配置选择。顶层 Makefile 有两个主要的任务：产生 vmlinux 文件和内核模块（module）。为了达到此目的，顶层 Makefile 递归的进入到内核的各个子目录中，分别调用位于这些子目录中的 Makefile。至于到底进入哪些子目录，取决于内核的配置。在顶层 Makefile 中，有一句：include arch/$(ARCH)/Makefile，包含了特定 CPU 体系结构下的 Makefile，这个 Makefile 中包含了平台相关的信息。</div>
<div>位于各个子目录下的 Makefile 同样也根据 .config 给出的配置信息，构造出当前配置下需要的源文件列表，并在文件的最后有 include $(TOPDIR)/Rules.make。</div>
<div>Rules.make 文件起着非常重要的作用，它定义了所有 Makefile 共用的编译规则。比如，如果需要将本目录下所有的 c 程序编译成汇编代码，需要在 Makefile 中有以下的编译规则：</div>
<pre class="prettyprint linenums">%.s: %.c<br />
$(CC) $(CFLAGS) -S $&lt; -o $@
</pre>
<div>有很多子目录下都有同样的要求，就需要在各自的 Makefile 中包含此编译规则，这会比较麻烦。而 Linux 内核中则把此类的编译规则统一放置到 Rules.make 中，并在各自的 Makefile 中包含进了 Rules.make（include Rules.make），这样就避免了在多个 Makefile 中重复同样的规则。对于上面的例子，在 Rules.make 中对应的规则为：</div>
<pre class="prettyprint linenums">%.s: %.c<br />
$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(CFLAGS_$(*F)) $(CFLAGS_$@) -S $&lt; -o $@
</pre>
<div><strong>2.2 Makefile 中的变量</strong></div>
<div>顶层 Makefile 定义并向环境中输出了许多变量，为各个子目录下的 Makefile 传递一些信息。有些变量，比如 SUBDIRS，不仅在顶层 Makefile 中定义并且赋初值，而且在 arch/*/Makefile 还作了扩充。</div>
<div>常用的变量有以下几类：</div>
<div>1） 版本信息&nbsp;<br />版本信息有：VERSION，PATCHLEVEL, SUBLEVEL, EXTRAVERSION，KERNELRELEASE。版本信息定义了当前内核的版本，比如 VERSION=2，PATCHLEVEL=4，SUBLEVEL=18，EXATAVERSION=-rmk7，它们共同构成内核的发行版本KERNELRELEASE：2.4.18-rmk7</div>
<div>2） CPU 体系结构：ARCH&nbsp;<br />在顶层 Makefile 的开头，用 ARCH 定义目标 CPU 的体系结构，比如 ARCH:=arm 等。许多子目录的 Makefile 中，要根据 ARCH 的定义选择编译源文件的列表。</div>
<div>3） 路径信息：TOPDIR, SUBDIRS&nbsp;<br />TOPDIR 定义了 Linux 内核源代码所在的根目录。例如，各个子目录下的 Makefile 通过 $(TOPDIR)/Rules.make 就可以找到 Rules.make 的位置。&nbsp;<br />SUBDIRS 定义了一个目录列表，在编译内核或模块时，顶层 Makefile 就是根据 SUBDIRS 来决定进入哪些子目录。SUBDIRS 的值取决于内核的配置，在顶层 Makefile 中 SUBDIRS 赋值为 kernel drivers mm fs net ipc lib；根据内核的配置情况，在 arch/*/Makefile 中扩充了 SUBDIRS 的值，参见4）中的例子。</div>
<div>4） 内核组成信息：HEAD, CORE_FILES, NETWORKS, DRIVERS, LIBS&nbsp;<br />Linux 内核文件 vmlinux 是由以下规则产生的：</div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">		vmlinux: $(CONFIGURATION) init/main.o init/version.o linuxsubdirs<br />
	$(LD) $(LINKFLAGS) $(HEAD) init/main.o init/version.o \<br />
		--start-group \<br />
		$(CORE_FILES) \<br />
		$(DRIVERS) \<br />
		$(NETWORKS) \<br />
		$(LIBS) \<br />
		--end-group \<br />
		-o vmlinux
		</pre>
</td>
</tr>
</tbody>
</table>
<div>可以看出，vmlinux 是由 HEAD、main.o、version.o、CORE_FILES、DRIVERS、NETWORKS 和 LIBS 组成的。这些变量（如 HEAD）都是用来定义连接生成 vmlinux 的目标文件和库文件列表。其中，HEAD在arch/*/Makefile 中定义，用来确定被最先链接进 vmlinux 的文件列表。比如，对于 ARM 系列的 CPU，HEAD 定义为：</div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">                   HEAD            := arch/arm/kernel/head-$(PROCESSOR).o \<br />
                   arch/arm/kernel/init_task.o
                   </pre>
</td>
</tr>
</tbody>
</table>
<div>表明 head-$(PROCESSOR).o 和 init_task.o 需要最先被链接到 vmlinux 中。PROCESSOR 为 armv 或 armo，取决于目标 CPU。 CORE_FILES，NETWORK，DRIVERS 和 LIBS 在顶层 Makefile 中定义，并且由 arch/*/Makefile 根据需要进行扩充。 CORE_FILES 对应着内核的核心文件，有 kernel/kernel.o，mm/mm.o，fs/fs.o，ipc/ipc.o，可以看出，这些是组成内核最为重要的文件。同时，arch/arm/Makefile 对 CORE_FILES 进行了扩充：</div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums"># arch/arm/Makefile<br />
# If we have a machine-specific directory, then include it in the build.<br />
MACHDIR         := arch/arm/mach-$(MACHINE)<br />
ifeq ($(MACHDIR),$(wildcard $(MACHDIR)))<br />
SUBDIRS         += $(MACHDIR)<br />
CORE_FILES      := $(MACHDIR)/$(MACHINE).o $(CORE_FILES)<br />
endif<br />
HEAD            := arch/arm/kernel/head-$(PROCESSOR).o \<br />
                   arch/arm/kernel/init_task.o<br />
SUBDIRS         += arch/arm/kernel arch/arm/mm arch/arm/lib arch/arm/nwfpe<br />
CORE_FILES      := arch/arm/kernel/kernel.o arch/arm/mm/mm.o $(CORE_FILES)<br />
LIBS            := arch/arm/lib/lib.a $(LIBS)
</pre>
</td>
</tr>
</tbody>
</table>
<div>5） 编译信息：CPP, CC, AS, LD, AR，CFLAGS，LINKFLAGS&nbsp;<br />在 Rules.make 中定义的是编译的通用规则，具体到特定的场合，需要明确给出编译环境，编译环境就是在以上的变量中定义的。针对交叉编译的要求，定义了 CROSS_COMPILE。比如：</div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">CROSS_COMPILE   = arm-linux-<br />
CC              = $(CROSS_COMPILE)gcc<br />
LD              = $(CROSS_COMPILE)ld<br />
......
</pre>
</td>
</tr>
</tbody>
</table>
<div>CROSS_COMPILE 定义了交叉编译器前缀 arm-linux-，表明所有的交叉编译工具都是以 arm-linux- 开头的，所以在各个交叉编译器工具之前，都加入了 $(CROSS_COMPILE)，以组成一个完整的交叉编译工具文件名，比如 arm-linux-gcc。&nbsp;<br />CFLAGS 定义了传递给 C 编译器的参数。&nbsp;<br />LINKFLAGS 是链接生成 vmlinux 时，由链接器使用的参数。LINKFLAGS 在 arm/*/Makefile 中定义，比如：</div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums"># arch/arm/Makefile<br />
LINKFLAGS       :=-p -X -T arch/arm/vmlinux.lds
</pre>
</td>
</tr>
</tbody>
</table>
<div>6） 配置变量CONFIG_*&nbsp;<br />.config 文件中有许多的配置变量等式，用来说明用户配置的结果。例如 CONFIG_MODULES=y 表明用户选择了 Linux 内核的模块功能。&nbsp;<br />.config 被顶层 Makefile 包含后，就形成许多的配置变量，每个配置变量具有确定的值：y 表示本编译选项对应的内核代码被静态编译进 Linux 内核；m 表示本编译选项对应的内核代码被编译成模块；n 表示不选择此编译选项；如果根本就没有选择，那么配置变量的值为空。</div>
<div><strong>2.3 Rules.make 变量</strong></div>
<div>前面讲过，Rules.make 是编译规则文件，所有的 Makefile 中都会包括 Rules.make。Rules.make 文件定义了许多变量，最为重要是那些编译、链接列表变量。</div>
<div>O_OBJS，L_OBJS，OX_OBJS，LX_OBJS：本目录下需要编译进 Linux 内核 vmlinux 的目标文件列表，其中 OX_OBJS 和 LX_OBJS 中的 "X" 表明目标文件使用了 EXPORT_SYMBOL 输出符号。</div>
<div>M_OBJS，MX_OBJS：本目录下需要被编译成可装载模块的目标文件列表。同样，MX_OBJS 中的 "X" 表明目标文件使用了 EXPORT_SYMBOL 输出符号。</div>
<div>O_TARGET，L_TARGET：每个子目录下都有一个 O_TARGET 或 L_TARGET，Rules.make 首先从源代码编译生成 O_OBJS 和 OX_OBJS 中所有的目标文件，然后使用 $(LD) -r 把它们链接成一个 O_TARGET 或 L_TARGET。O_TARGET 以 .o 结尾，而 L_TARGET 以 .a 结尾。</div>
<div><strong>2.4 子目录 Makefile</strong></div>
<div>子目录 Makefile 用来控制本级目录以下源代码的编译规则。我们通过一个例子来讲解子目录 Makefile 的组成：</div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">#<br />
# Makefile for the linux kernel.<br />
#<br />
# All of the (potential) objects that export symbols.<br />
# This list comes from 'grep -l EXPORT_SYMBOL *.[hc]'.<br />
export-objs	:= tc.o<br />
# Object file lists.<br />
obj-y		:=<br />
obj-m		:=<br />
obj-n		:=<br />
obj-		:=<br />
obj-$(CONFIG_TC) += tc.o<br />
obj-$(CONFIG_ZS) += zs.o<br />
obj-$(CONFIG_VT) += lk201.o lk201-map.o lk201-remap.o<br />
# Files that are both resident and modular: remove from modular.<br />
obj-m		:= $(filter-out $(obj-y), $(obj-m))<br />
# Translate to Rules.make lists.<br />
L_TARGET	:= tc.a<br />
L_OBJS		:= $(sort $(filter-out $(export-objs), $(obj-y)))<br />
LX_OBJS		:= $(sort $(filter     $(export-objs), $(obj-y)))<br />
M_OBJS		:= $(sort $(filter-out $(export-objs), $(obj-m)))<br />
MX_OBJS		:= $(sort $(filter     $(export-objs), $(obj-m)))<br />
include $(TOPDIR)/Rules.make
</pre>
</td>
</tr>
</tbody>
</table>
<div>a) 注释&nbsp;<br />对 Makefile 的说明和解释，由#开始。</div>
<div>b) 编译目标定义&nbsp;<br />类似于 obj-$(CONFIG_TC) += tc.o 的语句是用来定义编译的目标，是子目录 Makefile 中最重要的部分。编译目标定义那些在本子目录下，需要编译到 Linux 内核中的目标文件列表。为了只在用户选择了此功能后才编译，所有的目标定义都融合了对配置变量的判断。&nbsp;<br />前面说过，每个配置变量取值范围是：y，n，m 和空，obj-$(CONFIG_TC) 分别对应着 obj-y，obj-n，obj-m，obj-。如果 CONFIG_TC 配置为 y，那么 tc.o 就进入了 obj-y 列表。obj-y 为包含到 Linux 内核 vmlinux 中的目标文件列表；obj-m 为编译成模块的目标文件列表；obj-n 和 obj- 中的文件列表被忽略。配置系统就根据这些列表的属性进行编译和链接。&nbsp;<br />export-objs 中的目标文件都使用了 EXPORT_SYMBOL() 定义了公共的符号，以便可装载模块使用。在 tc.c 文件的最后部分，有 "EXPORT_SYMBOL(search_tc_card);"，表明 tc.o 有符号输出。&nbsp;<br />这里需要指出的是，对于编译目标的定义，存在着两种格式，分别是老式定义和新式定义。老式定义就是前面 Rules.make 使用的那些变量，新式定义就是 obj-y，obj-m，obj-n 和 obj-。Linux 内核推荐使用新式定义，不过由于 Rules.make 不理解新式定义，需要在 Makefile 中的适配段将其转换成老式定义。</div>
<div>c) 适配段&nbsp;<br />适配段的作用是将新式定义转换成老式定义。在上面的例子中，适配段就是将 obj-y 和 obj-m 转换成 Rules.make 能够理解的 L_TARGET，L_OBJS，LX_OBJS，M_OBJS，MX_OBJS。&nbsp;<br />L_OBJS := $(sort $(filter-out $(export-objs), $(obj-y))) 定义了 L_OBJS 的生成方式：在 obj-y 的列表中过滤掉 export-objs（tc.o），然后排序并去除重复的文件名。这里使用到了 GNU Make 的一些特殊功能，具体的含义可参考 Make 的文档（info make）。</div>
<div>d) include $(TOPDIR)/Rules.make</div>
<div>3． 配置文件</div>
<div><strong>3.1 配置功能概述</strong></div>
<div>除了 Makefile 的编写，另外一个重要的工作就是把新功能加入到 Linux 的配置选项中，提供此项功能的说明，让用户有机会选择此项功能。所有的这些都需要在 config.in 文件中用配置语言来编写配置脚本，&nbsp;<br />在 Linux 内核中，配置命令有多种方式：</div>
<table>
<tbody>
<tr>
<td>配置命令</td>
<td>解释脚本</td>
</tr>
<tr>
<td>Make config, make oldconfig</td>
<td>scripts/Configure</td>
</tr>
<tr>
<td>Make menuconfig</td>
<td>scripts/Menuconfig</td>
</tr>
<tr>
<td>Make xconfig</td>
<td>scripts/tkparse</td>
</tr>
</tbody>
</table>
<div>以字符界面配置（make config）为例，顶层 Makefile 调用 scripts/Configure， 按照 arch/arm/config.in 来进行配置。命令执行完后产生文件 .config，其中保存着配置信息。下一次再做 make config 将产生新的 .config 文件，原 .config 被改名为 .config.old</div>
<div><strong>3.2 配置语言</strong></div>
<div>1） 顶层菜单&nbsp;<br />mainmenu_name /prompt/ /prompt/ 是用'或"包围的字符串，'与"的区别是'&hellip;'中可使用$引用变量的值。mainmenu_name 设置最高层菜单的名字，它只在 make xconfig 时才会显示。</div>
<div>2） 询问语句</div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">        	    bool            /prompt/ /symbol/<br />
        hex             /prompt/ /symbol/ /word/<br />
        int             /prompt/ /symbol/ /word/<br />
        string          /prompt/ /symbol/ /word/<br />
        tristate        /prompt/ /symbol/
        </pre>
</td>
</tr>
</tbody>
</table>
<div>询问语句首先显示一串提示符 /prompt/，等待用户输入，并把输入的结果赋给 /symbol/ 所代表的配置变量。不同的询问语句的区别在于它们接受的输入数据类型不同，比如 bool 接受布尔类型（ y 或 n ），hex 接受 16 进制数据。有些询问语句还有第三个参数 /word/，用来给出缺省值。</div>
<div>3） 定义语句</div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">                define_bool     /symbol/ /word/<br />
        define_hex      /symbol/ /word/<br />
        define_int      /symbol/ /word/<br />
        define_string   /symbol/ /word/<br />
        define_tristate /symbol/ /word/
        </pre>
</td>
</tr>
</tbody>
</table>
<div>不同于询问语句等待用户输入，定义语句显式的给配置变量 /symbol/ 赋值 /word/。</div>
<div>4） 依赖语句</div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">
        dep_bool        /prompt/ /symbol/ /dep/ ...<br />
        dep_mbool       /prompt/ /symbol/ /dep/ ...<br />
        dep_hex         /prompt/ /symbol/ /word/ /dep/ ...<br />
        dep_int         /prompt/ /symbol/ /word/ /dep/ ...<br />
        dep_string      /prompt/ /symbol/ /word/ /dep/ ...<br />
        dep_tristate    /prompt/ /symbol/ /dep/ ...
        </pre>
</td>
</tr>
</tbody>
</table>
<div>与询问语句类似，依赖语句也是定义新的配置变量。不同的是，配置变量/symbol/的取值范围将依赖于配置变量列表/dep/ &hellip;。这就意味着：被定义的配置变量所对应功能的取舍取决于依赖列表所对应功能的选择。以dep_bool为例，如果/dep/ &hellip;列表的所有配置变量都取值y，则显示/prompt/，用户可输入任意的值给配置变量/symbol/，但是只要有一个配置变量的取值为n，则/symbol/被强制成n。&nbsp;<br />不同依赖语句的区别在于它们由依赖条件所产生的取值范围不同。</div>
<div>5） 选择语句</div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">choice          /prompt/ /word/ /word/
</pre>
</td>
</tr>
</tbody>
</table>
<p>choice 语句首先给出一串选择列表，供用户选择其中一种。比如 Linux for ARM 支持多种基于 ARM core 的 CPU，Linux 使用 choice 语句提供一个 CPU 列表，供用户选择：</p>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">                  choice 'ARM system type' \<br />
        "Anakin                 CONFIG_ARCH_ANAKIN \<br />
         Archimedes/A5000       CONFIG_ARCH_ARCA5K \<br />
         Cirrus-CL-PS7500FE     CONFIG_ARCH_CLPS7500 \<br />
			&hellip;&hellip;<br />
         SA1100-based           CONFIG_ARCH_SA1100 \<br />
         Shark                  CONFIG_ARCH_SHARK" RiscPC
         </pre>
</td>
</tr>
</tbody>
</table>
<div>Choice 首先显示 /prompt/，然后将 /word/ 分解成前后两个部分，前部分为对应选择的提示符，后部分是对应选择的配置变量。用户选择的配置变量为 y，其余的都为 n。</div>
<div>6） if语句</div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">                if [ /expr/ ] ; then<br />
          /statement/<br />
          ...<br />
        fi

        if [ /expr/ ] ; then<br />
          /statement/<br />
          ...<br />
        else<br />
          /statement/<br />
          ...<br />
        fi
        </pre>
</td>
</tr>
</tbody>
</table>
<div>if 语句对配置变量（或配置变量的组合）进行判断，并作出不同的处理。判断条件 /expr/ 可以是单个配置变量或字符串，也可以是带操作符的表达式。操作符有：=，!=，-o，-a 等。</div>
<div>7） 菜单块（menu block）语句</div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">mainmenu_option next_comment<br />
comment '&hellip;..'<br />
&hellip;<br />
endmenu
</pre>
</td>
</tr>
</tbody>
</table>
<div>引入新的菜单。在向内核增加新的功能后，需要相应的增加新的菜单，并在新菜单下给出此项功能的配置选项。Comment 后带的注释就是新菜单的名称。所有归属于此菜单的配置选项语句都写在 comment 和 endmenu 之间。</div>
<div>8） Source 语句&nbsp;<br />source /word/&nbsp;<br />/word/ 是文件名，source 的作用是调入新的文件。</div>
<div><strong>3.3 缺省配置</strong></div>
<div>Linux 内核支持非常多的硬件平台，对于具体的硬件平台而言，有些配置就是必需的，有些配置就不是必需的。另外，新增加功能的正常运行往往也需要一定的先决条件，针对新功能，必须作相应的配置。因此，特定硬件平台能够正常运行对应着一个最小的基本配置，这就是缺省配置。</div>
<div>Linux 内核中针对每个 ARCH 都会有一个缺省配置。在向内核代码增加了新的功能后，如果新功能对于这个 ARCH 是必需的，就要修改此 ARCH 的缺省配置。修改方法如下（在 Linux 内核根目录下）：</div>
<ol><li>备份 .config 文件</li>
<li>cp arch/arm/deconfig .config</li>
<li>修改 .config</li>
<li>cp .config arch/arm/deconfig</li>
<li>恢复 .config</li></ol>
<div>如果新增的功能适用于许多的 ARCH，只要针对具体的 ARCH，重复上面的步骤就可以了。</div>
<div><strong>3.4 help file</strong></div>
<div>大家都有这样的经验，在配置 Linux 内核时，遇到不懂含义的配置选项，可以查看它的帮助，从中可得到选择的建议。下面我们就看看如何给给一个配置选项增加帮助信息。</div>
<div>所有配置选项的帮助信息都在 Documentation/Configure.help 中，它的格式为：</div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">&lt;description&gt;<br />
&lt;variable name&gt;<br />
&lt;help file&gt;
</pre>
</td>
</tr>
</tbody>
</table>
<div>&lt;description&gt; 给出本配置选项的名称，&lt;variable name&gt; 对应配置变量，&lt;help file&gt; 对应配置帮助信息。在帮助信息中，首先简单描述此功能，其次说明选择了此功能后会有什么效果，不选择又有什么效果，最后，不要忘了写上"如果不清楚，选择 N（或者）Y"，给不知所措的用户以提示。</div>
<div>4． 实例</div>
<div>对于一个开发者来说，将自己开发的内核代码加入到 Linux 内核中，需要有三个步骤。首先确定把自己开发代码放入到内核的位置；其次，把自己开发的功能增加到 Linux 内核的配置选项中，使用户能够选择此功能；最后，构建子目录 Makefile，根据用户的选择，将相应的代码编译到最终生成的 Linux 内核中去。下面，我们就通过一个简单的例子--test driver，结合前面学到的知识，来说明如何向 Linux 内核中增加新的功能。</div>
<div><strong>4.1 目录结构</strong></div>
<div>test driver 放置在 drivers/test/ 目录下：</div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">$cd drivers/test<br />
$tree<br />
.<br />
|-- Config.in<br />
|-- Makefile<br />
|-- cpu<br />
|   |-- Makefile<br />
|   `-- cpu.c<br />
|-- test.c<br />
|-- test_client.c<br />
|-- test_ioctl.c<br />
|-- test_proc.c<br />
|-- test_queue.c<br />
`-- test<br />
    |-- Makefile<br />
    `-- test.c
    </pre>
</td>
</tr>
</tbody>
</table>
<div><strong>4.2 配置文件</strong></div>
<div>1） drivers/test/Config.in</div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">#<br />
# TEST driver configuration<br />
#<br />
mainmenu_option next_comment<br />
comment 'TEST Driver'<br />
bool 'TEST support' CONFIG_TEST<br />
if [ "$CONFIG_TEST" = "y" ]; then<br />
  tristate 'TEST user-space interface' CONFIG_TEST_USER<br />
  bool 'TEST CPU ' CONFIG_TEST_CPU<br />
fi<br />
endmenu
</pre>
</td>
</tr>
</tbody>
</table>
<div>由于 test driver 对于内核来说是新的功能，所以首先创建一个菜单 TEST Driver。然后，显示 "TEST support"，等待用户选择；接下来判断用户是否选择了 TEST Driver，如果是（CONFIG_TEST=y），则进一步显示子功能：用户接口与 CPU 功能支持；由于用户接口功能可以被编译成内核模块，所以这里的询问语句使用了 tristate（因为 tristate 的取值范围包括 y、n 和 m，m 就是对应着模块）。</div>
<div>2） arch/arm/config.in&nbsp;<br />在文件的最后加入：source drivers/test/Config.in，将 TEST Driver 子功能的配置纳入到 Linux 内核的配置中。</div>
<div><strong>4.3 Makefile</strong></div>
<div>1）drivers/test/Makefile</div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">
#       drivers/test/Makefile<br />
#<br />
#       Makefile for the TEST.<br />
#<br />
SUB_DIRS     :=<br />
MOD_SUB_DIRS := $(SUB_DIRS)<br />
ALL_SUB_DIRS := $(SUB_DIRS) cpu<br />
L_TARGET := test.a<br />
export-objs := test.o test_client.o<br />
obj-$(CONFIG_TEST)              += test.o test_queue.o test_client.o<br />
obj-$(CONFIG_TEST_USER)         += test_ioctl.o<br />
obj-$(CONFIG_PROC_FS)           += test_proc.o<br />
subdir-$(CONFIG_TEST_CPU)       += cpu<br />
include $(TOPDIR)/Rules.make<br />
clean:<br />
        for dir in $(ALL_SUB_DIRS); do make -C $$dir clean; done<br />
        rm -f *.[oa] .*.flags
        </pre>
</td>
</tr>
</tbody>
</table>
<div>drivers/test 目录下最终生成的目标文件是 test.a。在 test.c 和 test-client.c 中使用了 EXPORT_SYMBOL 输出符号，所以 test.o 和 test-client.o 位于 export-objs 列表中。然后，根据用户的选择（具体来说，就是配置变量的取值），构建各自对应的 obj-* 列表。由于 TEST Driver 中包一个子目录 cpu，当 CONFIG_TEST_CPU=y（即用户选择了此功能）时，需要将 cpu 目录加入到 subdir-y 列表中。</div>
<div>2）drivers/test/cpu/Makefile</div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">
#       drivers/test/test/Makefile<br />
#<br />
#       Makefile for the TEST CPU<br />
#<br />
SUB_DIRS     :=<br />
MOD_SUB_DIRS := $(SUB_DIRS)<br />
ALL_SUB_DIRS := $(SUB_DIRS)<br />
L_TARGET := test_cpu.a<br />
obj-$(CONFIG_test_CPU)       += cpu.o<br />
include $(TOPDIR)/Rules.make<br />
clean:<br />
        rm -f *.[oa] .*.flags
        </pre>
</td>
</tr>
</tbody>
</table>
<div>3）drivers/Makefile</div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">&hellip;&hellip;<br />
subdir-$(CONFIG_TEST)		+= test<br />
&hellip;&hellip;<br />
include $(TOPDIR)/Rules.make
</pre>
</td>
</tr>
</tbody>
</table>
<div>在 drivers/Makefile 中加入 subdir-$(CONFIG_TEST)+= test，使得在用户选择 TEST Driver 功能后，内核编译时能够进入 test 目录。</div>
<div>4）Makefile</div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">&hellip;&hellip;<br />
DRIVERS-$(CONFIG_PLD) += drivers/pld/pld.o<br />
DRIVERS-$(CONFIG_TEST) += drivers/test/test.a<br />
DRIVERS-$(CONFIG_TEST_CPU) += drivers/test/cpu/test_cpu.a<br />
DRIVERS := $(DRIVERS-y)<br />
&hellip;&hellip;
</pre>
</td>
</tr>
</tbody>
</table>
<div>在顶层 Makefile 中加入 DRIVERS-$(CONFIG_TEST) += drivers/test/test.a 和 DRIVERS-$(CONFIG_TEST_CPU) += drivers/test/cpu/test_cpu.a。如何用户选择了 TEST Driver，那么 CONFIG_TEST 和 CONFIG_TEST_CPU 都是 y，test.a 和 test_cpu.a 就都位于 DRIVERS-y 列表中，然后又被放置在 DRIVERS 列表中。在前面曾经提到过，Linux 内核文件 vmlinux 的组成中包括 DRIVERS，所以 test.a 和 test_cpu.a 最终可被链接到 vmlinux 中。</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvp1jqx.html">linux poll函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pmlo49.html">event</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwrjgk9.html">android4&period;4以上，快捷实现标题栏透明</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmmx3l9.html">MySQL高可用性分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd1j148.html">linq  xml读取</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnxj30q.html">windows 7 共享，未授予用户在此计算机上的请求登录类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xr7zw9.html">mysql 1067 进程意外终止 无法启动</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wlpe3q.html">Objective-C学习篇01&mdash;类的声明与实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd3d2y8.html">vagrant拷贝后vagrant file需要加的配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p0xmj8.html">C&num;开发 &OpenCurlyDoubleQuote;因为某项目未能生成&comma;所以无法发布&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgnmzd8.html">Log4J1升级Log4J2</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp57pjq.html">Android Studio没有导包快捷键怎么办</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wolegq.html">There are multiple modules with names that only differ in casing&period; 黄色warning</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2j04y9.html">python笔记16-函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o13371q.html">自动化测试-6&period;selenium的css定位</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r5rpm9.html">MangoDB学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve2ypx9.html">Storm工作流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmxdd09.html">php 中 FastCGI与cgi的关系，何为fastcgi</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em7oex9.html">MVC MVP   MVVM 图解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1veog6q.html">document&period;getElementsByName和document&period;getElementById用法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/960g1y49.html">【BZOJ4830】&lbrack;HNOI2017&rsqb;抛硬币（组合计数，拓展卢卡斯定理）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll7y61q.html">【转】Linux 移动或重命名文件&sol;目录－mv 的10个实用例子</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2zo40q.html">【bzoj1568】 JSOI2008&mdash;Blue Mary开公司</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gvxp0q.html">&lbrack;hihocoder1509&rsqb;&lbrack;异或排序&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25nwyoq.html">关于：HTTP Header -&amp;gt&semi; Content-Type&colon; text&sol;plain Cache-Control&colon; no-cache IE浏览器弹出错误下载对话</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4j2z1eq.html">一次完整的 HTTP 请求过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r53gvrq.html">线程Thread类</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1rzk09.html">解决IIS8中 URLRewriter 不能使用的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7owee18.html">spring &commat;Transactional注解参数详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rnvj58.html">Java&lowbar;myBatis&lowbar;逆向工程</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
